/*

  SjASMPlus Z80 Cross Compiler - modified - SAVECPCSNA extension

  Copyright (c) 2006 Sjoerd Mastijn (original SW)

  This software is provided 'as-is', without any express or implied warranty.
  In no event will the authors be held liable for any damages arising from the
  use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it freely,
  subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not claim
	 that you wrote the original software. If you use this software in a product,
	 an acknowledgment in the product documentation would be appreciated but is
	 not required.

  2. Altered source versions must be plainly marked as such, and must not be
	 misrepresented as being the original software.

  3. This notice may not be removed or altered from any source distribution.

*/

// io_cpc_ldrs.h

// CPC464 loader

const byte SaveCDT_AmstradCPC464[] = {
	0x3E, 0xFF, 0xCD, 0x6B, 0xBC, 0x3A, 0x26, 0x80, 0xB7, 0x28, 0x0B, 0x21, 0x00, 0xC0, 0x11, 0x00,
	0x40, 0x3E, 0x16, 0xCD, 0xA1, 0xBC, 0x2A, 0x27, 0x80, 0xE5, 0x2A, 0x29, 0x80, 0xED, 0x5B, 0x2B,
	0x80, 0x3E, 0x16, 0xC3, 0xA1, 0xBC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

constexpr aint SaveCDT_AmstradCPC464_ORG = 0x8000;
constexpr aint SaveCDT_AmstradCPC464_Len = sizeof(SaveCDT_AmstradCPC464);
constexpr aint SaveCDT_AmstradCPC464_Settings = 0x26; // Offset to "Settings" block

// CPC6128 loader

const byte SaveCDT_AmstradCPC6128[] = {
	0x3E, 0xFF, 0xCD, 0x6B, 0xBC, 0x3A, 0x56, 0x80, 0xB7, 0x28, 0x0B, 0x21, 0x00, 0xC0, 0x11, 0x00,
	0x40, 0x3E, 0x16, 0xCD, 0xA1, 0xBC, 0x21, 0x5D, 0x80, 0x7E, 0x23, 0xB7, 0x28, 0x28, 0xF5, 0x7E,
	0x23, 0xF6, 0xC0, 0x06, 0x74, 0x4F, 0xF3, 0xED, 0x49, 0x4E, 0x23, 0x46, 0x23, 0x5E, 0x23, 0x56,
	0x23, 0xE5, 0x21, 0x00, 0x40, 0x09, 0x3E, 0x16, 0xCD, 0xA1, 0xBC, 0x01, 0xC0, 0x74, 0xED, 0x49,
	0xE1, 0xFB, 0xF1, 0x3D, 0x20, 0xD8, 0x2A, 0x57, 0x80, 0xE5, 0x2A, 0x59, 0x80, 0xED, 0x5B, 0x5B,
	0x80, 0x3E, 0x16, 0xC3, 0xA1, 0xBC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

constexpr aint SaveCDT_AmstradCPC6128_ORG = 0x8000;
constexpr aint SaveCDT_AmstradCPC6128_Len = sizeof(SaveCDT_AmstradCPC6128);
constexpr aint SaveCDT_AmstradCPC6128_Settings = 0x56;
constexpr aint SaveCDT_AmstradCPC6128_Pages = 0x5D;
constexpr aint SaveCDT_AmstradCPC6128_PageEntrySize = 0x05;

// eof io_cpc_ldrs.h
